//+------------------------------------------------------------------+
//|                                             Risdyanto-Trader.mq4 |
//|                                 Copyright  2008, Risdyanto    
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Risdyanto"
#property link      ""

int numBars  = 1;
extern int lot      = 1;
extern int takeprofit =250;
extern int stop = 50;
extern bool PakeTrailing=true;
extern int TrailingStop=50;
extern int StartTrail=100;
extern int BatasOrder=8;
double open;
double stopbuy;
double stopsell;
string trendType;
extern int timeFrame = 1;
extern int maPeriod = 4;
int slippage = 3;
extern int demark=12;
extern bool tradebalance=true;
extern double MovingPeriod       = 70;
extern double MovingShift        = 0;
string mark;
extern bool pakejam=true;
extern int dari=4;
extern int sampe=11;
string filter;
int count;
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
if(CheckTodaysOrders() >= BatasOrder){
return(0); // abort
}
  if (pakejam) 
  {bool is_siesta=false;
   if ( Hour()>= dari && Hour()<=sampe && DayOfWeek()>=1 && DayOfWeek()<=5 )
   is_siesta=true;}
    
  if (is_siesta==true) 
  {
  MarketAnalize();
  if(OrdersTotal()==0)
   CheckForOpen();
  else
   CheckForClose();
  }

   return(0);
}

void MarketAnalize()
{
  for(int k = 0;k<=numBars;k++)
  { open      = iOpen (Symbol(),timeFrame,0);
    stopbuy   = iLow  (Symbol(),timeFrame,k);
    stopsell  = iHigh (Symbol(),timeFrame,k);  }   
  
 double MA = iMA(Symbol(),timeFrame,maPeriod,0,MODE_SMA,PRICE_CLOSE,0);
  
  if(Ask > MA)
  { trendType = "bullish";  }
  if(Bid < MA)
  { trendType = "bearish";  }
  
 
}

void CheckForOpen()
{RefreshRates();
   double ma;
  //---- get Moving Average 
   ma=iMA(Symbol(),timeFrame,MovingPeriod,MovingShift,MODE_SMA,PRICE_CLOSE,0);
   
//---- sell conditions

    if(Open[1]>ma && Close[1]<ma)  
     {
      OrderSend(Symbol(),OP_SELL,lot,Bid,3,Bid+stop*Point,Bid-takeprofit*Point,"",0,0,Red);
      if (tradebalance)
      {OrderSend(Symbol(),OP_BUY,lot,Ask,3,Ask-stop*Point,Ask+takeprofit*Point);}
      return;
     }
//---- buy conditions
   if(Open[1]<ma && Close[1]>ma)  
     {
      OrderSend(Symbol(),OP_BUY,lot,Ask,3,Ask-stop*Point,Ask+takeprofit*Point,"",0,0,Blue);
      if (tradebalance)
      {OrderSend(Symbol(),OP_SELL,lot,Bid,3,Bid+stop*Point,Bid-takeprofit*Point); }
      return;
     }
 /*   if ((iDeMarker(Symbol(),timeFrame,demark,0)>0.87)&& (trendType=="bullish"))
     {  OrderSend(Symbol(),OP_BUY,lot,Ask,3,Ask-stop*Point,Ask+takeprofit*Point);
     if (tradebalance)
      {OrderSend(Symbol(),OP_SELL,lot,Bid,3,Bid+stop*Point,Bid-takeprofit*Point); }
     }
 
  //  if ((iDeMarker(Symbol(),timeFrame,demark,0)<0.13) && (trendType=="bearish"))
     { OrderSend(Symbol(),OP_SELL,lot,Bid,3,Bid+stop*Point,Bid-takeprofit*Point); 
     if (tradebalance)
      {OrderSend(Symbol(),OP_BUY,lot,Ask,3,Ask-stop*Point,Ask+takeprofit*Point);}
     }*/
}

void CheckForClose()
{
 OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
if (PakeTrailing){
 if(OrderType()==OP_BUY)
 {
 if(Ask>OrderOpenPrice()+Point*StartTrail) 
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
          
              
  /* if((Ask>OrderOpenPrice()+Point*130)&&(OrderStopLoss()<(OrderOpenPrice()+Point*50)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*50,OrderTakeProfit(),0,Blue);
     if((Ask>OrderOpenPrice()+Point*200)&&(OrderStopLoss()<(OrderOpenPrice()+Point*150)))
       OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*150,OrderTakeProfit(),0,Blue);    
        if((Ask>OrderOpenPrice()+Point*350)&&(OrderStopLoss()<(OrderOpenPrice()+Point*300)))
         OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*300,OrderTakeProfit(),0,Blue);
          if((Ask>OrderOpenPrice()+Point*400)&&(OrderStopLoss()<(OrderOpenPrice()+Point*350)))
           OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*350,OrderTakeProfit(),0,Blue);*/
  }  
 if(OrderType()==OP_SELL)
 {  
  if(Bid<OrderOpenPrice()-Point*StartTrail) 
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           
   /*       if((Bid<OrderOpenPrice()-Point*130)&&(OrderStopLoss()>(OrderOpenPrice()-Point*50)))
          OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*50,OrderTakeProfit(),0,Blue);     
         if((Bid<OrderOpenPrice()-Point*200)&&(OrderStopLoss()>(OrderOpenPrice()-Point*150)))
        OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*150,OrderTakeProfit(),0,Blue);     
       if((Bid<OrderOpenPrice()-Point*350)&&(OrderStopLoss()>(OrderOpenPrice()-Point*300)))
      OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*300,OrderTakeProfit(),0,Blue);     
     if((Bid<OrderOpenPrice()-Point*400)&&(OrderStopLoss()>(OrderOpenPrice()-Point*350)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*350,OrderTakeProfit(),0,Blue);   */ 
 } }    
//+------------------------------------------------------------------+
}

// function
int CheckTodaysOrders()
{
int TodaysOrders = 0;
for(int i = OrdersTotal()-1; i >=0; i--){
OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
if(TimeDayOfYear(OrderOpenTime()) == TimeDayOfYear(TimeCurrent())){
TodaysOrders += 1;
}
}
for(i = OrdersHistoryTotal()-1; i >=0; i--){
OrderSelect(i, SELECT_BY_POS,MODE_HISTORY);
if(TimeDayOfYear(OrderOpenTime()) == TimeDayOfYear(TimeCurrent())){
TodaysOrders += 1;
}
}
return(TodaysOrders);
}
 
//+------------------------------------------------------------------+